----------------------------------------------------------------------------------
-- Company: 
-- Engineer: Mostafa Darvishi
-- 
-- Create Date: 05/30/2017 07:33:12 PM
-- Design Name: 
-- Module Name: ringOscillator - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;
------------------------------------------------------------------------------------------
entity ringOscillator is	
  port (	en	: in  std_logic ;
            cut : in  std_logic ;
			y	: out std_logic);
			
end entity ; -- ringOscillator
------------------------------------------------------------------------------------------
architecture behavior of ringOscillator is
    
    attribute KEEP : string;
    attribute S    : string;
    attribute keep_hierarchy    :  string;

    
	---------------------------------------------
	component inverter is
	  port (	x	: in  std_logic ;
				xn	: out std_logic);
	end component ; -- inverter
	---------------------------------------------
	
	--signal inv_array	: std_logic_vector(7 downto 0) := (others => '0');
	signal inv_array	: std_logic := '0';
	signal xn           : std_logic := '0';
	
	attribute KEEP of inv_array : signal is "TRUE";
    attribute KEEP of xn        : signal is "TRUE";
	attribute S    of inv_array : signal is "TRUE";
	attribute S    of xn        : signal is "TRUE";
	
	attribute keep_hierarchy of inv   : label is "yes";


	

	

	
	attribute RLOC: string;
	--attribute RLOC of inv_array: signal is "X1Y0 X0Y0 X3Y0 X2Y0 X5Y0 X4Y0 X7Y0 X6Y0";
	--attribute RLOC of inv_array: signal is "X0Y8";
	
	
begin
	

	-- input AND
	--inv_array(0)	<= en and inv_array(7) when cut = '0' else en and inv_array(7 -2); 
	inv_array	<= en and xn    when cut = '0' else '0';
	
	--delayLine: for i in 0 to 7-1 generate
--	delayLine: generate
		inv: inverter port map(inv_array, xn);
--	end generate delayLine;
		
	-- output AND
	
	--y	<= inv_array;
	y	<= xn;


end architecture ; -- behavior
