----------------------------------------------------------------------------------
-- Company: 
-- Engineer:  Mostafa Darvishi
-- 
-- Create Date:    20:16:36 05/24/2017 
-- Design Name: 
-- Module Name:    counter1 - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
use ieee.std_logic_unsigned.all;
library UNISIM;
use UNISIM.VComponents.all;

entity counter1 is
    Port ( clk 	    : in  	STD_LOGIC;
           rst 	    : in  	STD_LOGIC;
			  en  	    : in  	STD_LOGIC;
           count 	    : out  	STD_LOGIC_VECTOR (31 downto 0);
			  ref_pulse  : out  STD_LOGIC);
end counter1;


architecture Behavioral of counter1 is


attribute keep : string;
attribute S    : string;






	signal countx 		 : std_logic_vector (31 downto 0) := (others => '0');
	signal ref_pulsex  : std_logic := '0';

	
	attribute keep of countx     : signal is "TRUE";
	attribute keep of ref_pulsex : signal is "TRUE";
	attribute S    of countx     : signal is "TRUE";
	attribute S    of ref_pulsex : signal is "TRUE";

	
	
	
begin

		process(clk)
		begin
				if (rising_edge(clk)) then
						if (rst = '1') then 
								countx <= (others=>'0');   --nxt <= (others=>'0');
						else
						   if (en = '1') then --new added
							countx <= countx + 1;
							if (countx = "00000000000000000000000000000000") then
									ref_pulsex <= '1';
							elsif (countx = "00000101111101011110000011110110") then  --111111111111111111111111111 = 1.34217727 sec  ,  101111101011110000011110110 = 1.000000 sec exact
									ref_pulsex <= '0';
									countx <= (others=>'0');
							end if;
							end if; -- new added
						end if;
				end if;
			end process;

count     <= countx;
ref_pulse <= ref_pulsex;

end Behavioral;

